#include "./mat.h"
#include <gsl/gsl_sf_gamma.h>

/*long double argum(zespolone z, bool czydodac=false)
{
  if (z==0) return 0;
  long double a=asinl(z.im()/z.modul());
  if (z.re()<0) if (z.im()>0) a=3.141592653589793-a; else a=-a-3.141592653589793;
  if (czydodac) if (a<0) a=a+2.0*3.141592653589793;
  return a;
  if (z.re()==0) z=z+0.0001;//if (z.im()>0) {return 1.570796326794897;} else {return -1.570796326794897;}
  if ((z.re()>0) && (z.im()>=0)) a=atanl(z.im()/z.re());
  if ((z.re()>0) && (z.im()<0)) a=-atanl(-z.im()/z.re());
  if ((z.re()<0) && (z.im()>=0)) a=-atanl(-z.im()/z.re())+3.141592653589793;
  if ((z.re()<0) && (z.im()<0)) a=atanl(z.im()/z.re())-3.141592653589793;
  if (a>3.141592653589793); a=a-3.141592653589793;
  return a;*/

const bool operator==(const zespolone& z1,const zespolone& z2)
{
  return (z1.re()==z2.re() && z1.im()==z2.im());
}
const bool operator!=(const zespolone& z1,const zespolone& z2)
{
  return (z1.re()!=z2.re() || z1.im()!=z2.im());
}

zespolone liczbazarg(double r,double phi)
{
  return gsl_complex_polar(r,phi);
}

const zespolone potega(const zespolone& z,const zespolone& w)
{
  if (z.isZero()) return zespolone();
  return gsl_complex_pow(z,w);
}

bool homografia(zespolone& z, zespolone a,zespolone b,zespolone c,zespolone d)
{
  zespolone v=c*z+d;
  if (v==0) {return false;}
  z=(a*z+b)*v.odwrot();
  return true;
}

bool zukowski(zespolone& z)
{
  if (z==0) return false;
  z=(z+z.odwrot())*0.5;
  return true;
}

bool expz(zespolone& z)
{
  z=gsl_complex_exp(z);
  return true;
}

bool kwadrat(zespolone& z, zespolone a, zespolone b)
{
  z=z*z+z*a+b;
  return true;
}

bool szescian(zespolone& z,zespolone a,zespolone b,zespolone c)
{
  z=z*z*z+z*z*a+z*b+c;
  return true;
}

bool digamma(zespolone& z)
{
  return false;
  // reszta jest jakas strasznie syfna
  double r=z.re();
  double i=z.im();
//  if ((r==(int)r) && i==0) return false;
  gsl_sf_result *x,*y;
  gsl_sf_lngamma_complex_e(r,i,x,y);
  z=liczbazarg(x->val,y->val);
  return true;
}
bool nakwadrat(zespolone& z)
{
  /*  long double aa=0.5;
  long double bb=2.0/3.0;
  long double cc=1.5;
  long double dd=1.0;
  zespolone w=z*z;
  zespolone u=w;
  zespolone k=zespolone(1.0,0.0);
  for (int n=1;n<1000; n++) {k=k+w*(aa*bb/(cc*dd)); aa++; bb++; cc++; dd++; w=w*u;}
  zespolone l=zespolone(0.0,0.0);
  for (int n=1;n<50; n++) {l=l+w*(aa*bb/(cc*dd)); aa++; bb++; cc++; dd++; w=w*u;}
  if (l.modul2()>k.modul2()*0.1) return false;
  z=z*(k+l);*/
  return true; 
}
bool SC4(zespolone& z)
{
  if (z.im()<=0) return false;
  zespolone u=z;
  zespolone v=z;
  if (!arctangens(u)) return false;
  if (!arctangensh(v)) return false;
  z=v-u;
  return true; 
}
bool SC3(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone u=z*z-1.0;
  if (!squareroot(u)) return false;
  zespolone w=z+u;
  if (!logarithm(w)) return false;
  z=(z*u-w*3.0)*zespolone(0.0,-1.0)+1.5*3.141592653589793;
  return true;
}
bool logcoth(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w=z;
  if (!expz(w)) return false;
  if (w==1) return false;
  z=(w+1.0)*((w-1.0).odwrot());
  return logarithm(z);
}
bool SC2(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w=z*z*(-1.0)+1.0;
  if (!squareroot(w)) return false;
  zespolone u=z+w*zespolone(0.0,1.0);
  if (!logarithm(u)) return false;
  z=(z*w+zespolone(0.0,1.0)*u)*(-1.0/1.570796326794897)-1.0;
  return true;
}
bool bezcwiartki(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w=z;
  if (!squareroot(w)) return false;
  z=w*(z-3.0)*zespolone(0.0,-0.5);
  return true;
}
bool arctangens(zespolone& z)
{
  if (z.im()<0) return false;
  z=gsl_complex_arctan(z);
  return true;
}
bool arctangensh(zespolone& z)
{
  if (z.im()<0) return false;
  z=gsl_complex_arctanh(z);
  return true;
}
bool tangens(zespolone& z)
{
  zespolone w;
  
  
    w=gsl_complex_tan(z);
  
    //return false;
  z=w;
  return true;
}
bool arcsine(zespolone& z)
{
  if (z.im()<0) return false;
  zespolone w;
//  try
  //{
    w=gsl_complex_arcsin(z);
  //}
  //catch()
  //{
  //  return false;
  //}
  z=w;
  return true;
}
bool logarithm(zespolone& z)
{
  if (z.im()<=0) return false;
  z=gsl_complex_log(z);
 return true;
}
bool squareroot(zespolone& z)
{
  if (z==0) return true;
  z=gsl_complex_sqrt(z);
  return true;
}

bool przeksztalcenie(zespolone& z,zespolone a,zespolone b, zespolone c, zespolone d,int jakie)
{
  bool ok;
  switch (jakie) 
    {
    case 0: ok=homografia(z,a,b,c,d); break;
    case 1: ok=expz(z); break;
    case 2: ok=zukowski(z); break;
    case 3: ok=kwadrat(z,a,b); break;
    case 4: ok=szescian(z,a,b,c); break;
    case 5: ok=digamma(z);break;
    case 6: ok=nakwadrat(z);break;
    case 7: ok=arcsine(z); break;
    case 8: ok=logarithm(z);break;
    case 9: ok=squareroot(z); break;
    case 10: ok=tangens(z); break;
    case 11: ok=arctangens(z); break;
    case 12: ok=arctangensh(z); break;
    case 13: ok=bezcwiartki(z); break;
    case 14: ok=SC2(z); break;
    case 15: ok=logcoth(z); break;
    case 16: ok=SC3(z); break;
    case 17: ok=SC4(z); break;
    default: ok=false;
    }
  return ok;
}
char* nazwafunkcji(int n)
{
  switch (n)
    {
    case 0: return "Mobius transform z->(az+b)/(cz+d)";
    case 1: return "Exponential map z->exp(z)";
    case 2: return "Zukowski map z->(z+1/z)/2";
    case 3: return "Quadratic map z->z^2+az+b";
    case 4: return "Cubic map z->z^3+az^2+bz+c";
    case 5: return "Digamma z->dlog Gamma(z)";
    case 6: return "Experimental";
    case 7: return "z->Arc Sin(z), Im z>0";
    case 8: return "z->Log(z), Im z>0";
    case 9: return "z->z^(1/2), Im z>0";
    case 10: return "z->Tan(z), -pi/4<Re z<pi/4";
    case 11: return "z->Arc Tan(z), Im z>0";
    case 12: return "z->Ar TahH(z), Im z>0";
    case 13: return "Schwarz--Christoffel I, Im z>0";
    case 14: return "Schwarz--Christoffel II, Im z>0";
    case 15: return "z->log coth(z), Im(z)>0";
    case 16: return "Schwarz--Christoffel III, Im z>0";
    case 17: return "Schwarz--Christoffel IV, Im z>0";
    default: return "a";
    }
}
bool czygorna(int typfunkcji)
{
  switch (typfunkcji)
    {
    case 0: case 1: case 2: case 3: case 4: case 5: case 10: return false;
    default: return true;
    }
}
