#include "./moje.h"

moje::moje(QWidget *parent):QWidget(parent)
{
  CreateActions();
  CreateMenus();
  qwykres=new wykres(this);
  ConnectActionsToMenus();

  lab=new QTextEdit(QString("This program draws mobius transform z->(az+b)/(cz+d)\ 
of the complex plane. The image of the coloured lines on the left is drawn on the right\ 
hand side. You can change parameters a,b,c and d as well as move the centre of the coordinate\
system on the right hand side.%1\
Tips: If there are to few points on the right\
hand side picture, try pressing Ctrl+S or Alt+S").arg("\n"),this);
  lab->setReadOnly(true);
  lab->setFont(QFont("Helvetica",12));
 // lab->setMaximumHeight(80);

  lab2=new QTextEdit(this);
  // lab2->setMaximumHeight(80);

  connect(qwykres,SIGNAL(textchanged(QString)),lab2,SLOT(setText(QString)));

  lay=new QGridLayout(this);
  lay->setRowMinimumHeight(0,30);
  lay->addWidget(lab,1,0);
  lay->addWidget(qwykres,2,0);
  lay->addWidget(lab2,3,0);
  //lay->setRowStretch(1,10);
  setLayout(lay);
  
}

void moje::CreateActions()
{
  exitAct = new QAction(tr("E&xit"), this);
  exitAct->setShortcut(tr("Ctrl+Q"));
 
  doubleScaleSource=new QAction(tr("Zoom in source"),this);
  doubleScaleSource->setShortcut(tr("Ctrl+D"));

  halfScaleSource=new QAction(tr("Zoom out source"),this);
  halfScaleSource->setShortcut(tr("Ctrl+S"));

  doubleScaleTarget=new QAction(tr("Zoom in target"),this);
  doubleScaleTarget->setShortcut(tr("Alt+D"));

  halfScaleTarget=new QAction(tr("Zoom out target"),this);
  halfScaleTarget->setShortcut(tr("Alt+S"));

  ellipserescale=new QAction(tr("Rescale ellipse"),this);
  ellipserescale->setShortcut(tr("S"));

  horizontallines=new QAction(tr("Horizontal lines"),this);
  horizontallines->setShortcut(tr("H"));

  verticallines=new QAction(tr("Vertical lines"),this);
  verticallines->setShortcut(tr("V"));

  drawcircles=new QAction(tr("Circles"),this);
  drawellipses=new QAction(tr("Ellipses"),this);

  drawcircles->setShortcut(tr("C"));
  drawellipses->setShortcut(tr("E"));
  drawrays=new QAction(tr("Rays"),this);
  drawrays->setShortcut(tr("R"));

  lines=new QAction(tr("Horizontal and Vertical lines"),this);
  lines->setShortcut(tr("L"));

  circlesandlines=new QAction(tr("Circles and rays"),this);
  circlesandlines->setShortcut(tr("A"));

  Phomografia=new QAction(tr("Mobius transform"),this);
  Phomografia->setShortcut(tr("1"));
  Pexp=new QAction(tr("Exponent map"),this);
  Pexp->setShortcut(tr("2"));
  Pzukowski=new QAction(tr("Zukowski map"),this);
  Pzukowski->setShortcut(tr("3"));
  Pkwadrat=new QAction(tr("Quadratic map"),this);
  Pkwadrat->setShortcut(tr("4"));
  Pszescian=new QAction(tr("Cubic map"),this);
  Pszescian->setShortcut(tr("5"));
  Pdigamma=new QAction(tr("Digamma"),this);
  Pdigamma->setShortcut(tr("6"));
  Parcsine=new QAction(tr("Arc Sine"),this);
  Parcsine->setShortcut(tr("7"));
  Plogarithm=new QAction(tr("Logarithm"),this);
  Plogarithm->setShortcut(tr("8"));
  Psquareroot=new QAction(tr("Square root"),this);
  Psquareroot->setShortcut(tr("9"));
  Pnakwadrat=new QAction(tr("Experimental"),this);
  Pnakwadrat->setShortcut(tr("0"));
  Ptangens=new QAction(tr("Tangens"),this);
  Ptangens->setShortcut(tr("Ctrl+1"));
  Parctangens=new QAction(tr("Arc Tan"),this);
  Parctangens->setShortcut(tr("Ctrl+2"));
  Parctangensh=new QAction(tr("Ar Tanh"),this);
  Parctangensh->setShortcut(tr("Ctrl+3"));
  Pbezcwiartki=new QAction(tr("Schwarz--Christoffel I"),this);
  Pbezcwiartki->setShortcut(tr("Ctrl+4"));
  PschwarzchristII=new QAction(tr("Schwarz--Christoffel II"),this);
  PschwarzchristII->setShortcut(tr("Ctrl+5"));
  Plogcoth=new QAction(tr("Log coth"),this);
  Plogcoth->setShortcut(tr("Ctrl+6"));
  PschwarzchristIII=new QAction(tr("Schwarz--Christoffel III"),this);
  PschwarzchristIII->setShortcut(tr("Ctrl+7"));
  PschwarzchristIV=new QAction(tr("Schwarz--Christoffel IV"),this);
  PschwarzchristIV->setShortcut(tr("Ctrl+8"));
  
  linenumberincrease=new QAction(tr("Increase number of lines"),this);
  linenumberincrease->setShortcut(tr("I"));

  linenumberdecrease=new QAction(tr("Decrease number of lines"),this);
  linenumberdecrease->setShortcut(tr("D"));

  changevaluetarget=new QAction(tr("Change centre of target"),this);
  changevaluetarget->setShortcut(tr("T"));

  inftytoorigin=new QAction(tr("Move infinity to origin"),this);
  inftytoorigin->setShortcut(tr("O"));
  changemobius=new QAction(tr("Change parameters"),this);
  changemobius->setShortcut(tr("P"));

}

void moje::CreateMenus()
{
  pasekmenu=new QMenuBar(this);
  pasekmenu->setFont(QFont("Helvetica",12));
  pasekmenu->setMinimumWidth(250);

  fileMenu=new QMenu("File",this);
  fileMenu->setFont(QFont("Helvetica",12));
  fileMenu->addAction(exitAct);

  pasekmenu->addMenu(fileMenu);

  scaleMenu=new QMenu("Scale", this);
  scaleMenu->setFont(QFont("Helvetica",12));
  scaleMenu->addAction(doubleScaleSource);
  scaleMenu->addAction(halfScaleSource);
  scaleMenu->addAction(doubleScaleTarget);
  scaleMenu->addAction(halfScaleTarget);
  scaleMenu->addAction(ellipserescale);
  scaleMenu->addAction(changemobius);

  pasekmenu->addMenu(scaleMenu);

  viewMenu=new QMenu("View",this);
  viewMenu->setFont(QFont("Helvetica",12));
  viewMenu->addAction(horizontallines);
  viewMenu->addAction(verticallines);
  viewMenu->addAction(drawcircles);
  viewMenu->addAction(drawellipses);
  viewMenu->addAction(drawrays);
  viewMenu->addAction(lines);
  viewMenu->addAction(circlesandlines);
  viewMenu->addAction(linenumberincrease);
  viewMenu->addAction(linenumberdecrease);
  viewMenu->addAction(changevaluetarget);
  viewMenu->addAction(inftytoorigin);

  pasekmenu->addMenu(viewMenu);

  mapMenu=new QMenu("Select map",this);
  mapMenu->addAction(Phomografia);
  mapMenu->addAction(Pexp);
  mapMenu->addAction(Pzukowski);
  mapMenu->addAction(Pkwadrat);
  mapMenu->addAction(Pszescian);
  mapMenu->addSeparator();
  
  mapMenu->addAction(Pdigamma);
  mapMenu->addAction(Parcsine);
  mapMenu->addAction(Plogarithm);
  mapMenu->addAction(Psquareroot);
  mapMenu->addAction(Pnakwadrat);
  mapMenu->addSeparator();

  mapMenu->addAction(Ptangens);
  mapMenu->addAction(Parctangens);
  mapMenu->addAction(Parctangensh);
  mapMenu->addAction(Pbezcwiartki);
  mapMenu->addAction(PschwarzchristII);
  mapMenu->addSeparator();

  mapMenu->addAction(Plogcoth);
  mapMenu->addAction(PschwarzchristIII);
  mapMenu->addAction(PschwarzchristIV);

  mapMenu->setTearOffEnabled(true);

  pasekmenu->addMenu(mapMenu);
}

void moje::ConnectActionsToMenus()
{
  connect(exitAct, SIGNAL(triggered()), qwykres, SLOT(close()));
  connect(exitAct, SIGNAL(triggered()), this, SLOT(close()));

  connect(doubleScaleTarget,SIGNAL(triggered()),qwykres,SLOT(doublerangetarget()));
  connect(doubleScaleSource,SIGNAL(triggered()),qwykres,SLOT(doublerangesource()));
  connect(halfScaleTarget,SIGNAL(triggered()),qwykres,SLOT(halfrangetarget()));
  connect(halfScaleSource,SIGNAL(triggered()),qwykres,SLOT(halfrangesource()));
  connect(ellipserescale,SIGNAL(triggered()),qwykres,SLOT(changeellipsescale()));
  connect(horizontallines,SIGNAL(triggered()),qwykres,SLOT(liniepoziome()));
  connect(verticallines,SIGNAL(triggered()),qwykres,SLOT(liniepionowe()));
  connect(drawcircles,SIGNAL(triggered()),qwykres,SLOT(okregi()));
  connect(drawellipses,SIGNAL(triggered()),qwykres,SLOT(elipsy()));
  connect(drawrays,SIGNAL(triggered()),qwykres,SLOT(promienie()));
  connect(lines,SIGNAL(triggered()),qwykres,SLOT(linie()));
  connect(circlesandlines,SIGNAL(triggered()),qwykres,SLOT(okregiilinie()));
  
  connect(Phomografia,SIGNAL(triggered()),qwykres,SLOT(Shomografia()));
  connect(Pexp,SIGNAL(triggered()),qwykres,SLOT(Sexp()));
  connect(Pzukowski,SIGNAL(triggered()),qwykres,SLOT(Szukowski()));
  connect(Pkwadrat,SIGNAL(triggered()),qwykres,SLOT(Skwadrat()));
  connect(Pszescian,SIGNAL(triggered()),qwykres,SLOT(Sszescian()));
  connect(Pdigamma,SIGNAL(triggered()),qwykres,SLOT(Sdigamma()));
  connect(Parcsine,SIGNAL(triggered()),qwykres,SLOT(Sarcsine()));
  connect(Plogarithm,SIGNAL(triggered()),qwykres,SLOT(Slogarithm()));
  connect(Psquareroot,SIGNAL(triggered()),qwykres,SLOT(Ssquareroot()));
  connect(Pnakwadrat,SIGNAL(triggered()),qwykres,SLOT(Snakwadrat()));
  connect(Ptangens,SIGNAL(triggered()),qwykres,SLOT(Stangens()));
  connect(Parctangens,SIGNAL(triggered()),qwykres,SLOT(Sarctangens()));
  connect(Parctangensh,SIGNAL(triggered()),qwykres,SLOT(Sarctangensh()));
  connect(Pbezcwiartki,SIGNAL(triggered()),qwykres,SLOT(Sbezcwiartki()));
  connect(PschwarzchristII,SIGNAL(triggered()),qwykres,SLOT(SschwarzchristII()));
  connect(Plogcoth,SIGNAL(triggered()),qwykres,SLOT(Slogcoth()));
  connect(PschwarzchristIII,SIGNAL(triggered()),qwykres,SLOT(SschwarzchristIII()));
  connect(PschwarzchristIV,SIGNAL(triggered()),qwykres,SLOT(SschwarzchristIV()));

  connect(linenumberincrease,SIGNAL(triggered()),qwykres,SLOT(zwiekszilosclinii()));
  connect(linenumberdecrease,SIGNAL(triggered()),qwykres,SLOT(zmniejszilosclinii()));
  connect(changevaluetarget,SIGNAL(triggered()),qwykres,SLOT(changecentretarget()));
  connect(inftytoorigin,SIGNAL(triggered()),qwykres,SLOT(moveinfinitytoorigin()));
  connect(changemobius,SIGNAL(triggered()),qwykres,SLOT(parameterchangestart()));
}
